package lib::CheckGroups;

use NNML::Config qw($Config);
use NNML::Active qw($ACTIVE);
use NNML::Group;
use lib::Header;
use lib::Debug;

lib::Debug->level(1);
push @{$Config->{accept_article_hook}}, \&check_groups;

sub check_groups {
    my $art = shift;
    my ($head) = fetch_header($art);
    my @mygroup = split /,/, $head->{newsgroups};
    my $ret = "unwanted group: ". $head->{newsgroups} . "\n";
    my $modarate = '';

    lib::Debug->print(@mygroup);

    return 0 if $head->{control};

    for (@mygroup) {
	my $GROUP = $ACTIVE->group($_);
	lib::Debug->print($GROUP);
	next unless $GROUP;
	$moderate = moderated($art, $head) if $GROUP->post eq 'm';
	return $moderate if $moderate;
	$ret = 0 if $GROUP->{description};
    }

    return $ret;
}

sub moderated {
    my ($art, $head) = @_;

    return "moderated group: " . $head->{newsgroups} . "\n"
	unless $head->{approved};

    return 0;
}

1;

# end
