package lib::Control;

use NNML::Config qw($Config);
use NNML::Active qw($ACTIVE);
use NNML::Group;

use lib::Config;
use lib::Header;
use lib::Debug;

lib::Debug->level(1);
push @{$Config->{accept_article_hook}}, \&control;

open(USERS, "<$users") or die "Cannot open $users: $!";
while (<USERS>) {
    next if /^$/ or /^#/;
    @admin = (split)[0, 1] if /\sadmin/;
}
close(USERS);

sub control {
    my $art = shift;
    my ($head, $body) = fetch_header($art);

    return 0 unless $head->{control};

    lib::Debug->print($head->{control});

    my ($cmd, $param) = split /\s+/, $head->{control}, 2;
    return 0 unless defined &$cmd;

    \&$cmd($head, $body, $param);

    return 0;
}

sub cancel {
    my ($head, $body, $id) = @_;
    my ($arthead) = article_header($id);
    lib::Debug->print($id);

    return 0 unless $arthead;

    my $canceler = $head->{sender} || $head->{from};
    return 0 unless $canceler eq $arthead->{from} or
	$canceler eq $arthead->{sender};

    for (split /,/, $arthead->{newsgroups}) {
	my $group = $ACTIVE->group($_);
	my $ano = $group->article_by_id($id);
	$group->delete($ano) if defined $ano;
    }
    $ACTIVE->_write_active;

    print "$id is canceled\n";

    return 0;
}

sub newgroup {
    my ($head, $body, $param) = @_;
    my ($name, $mod) = split /\s+/, $param;
    my $group = $ACTIVE->group($name);
    my $dir = $name;
    my $descr = '?';
    my $pat = $name;
    $pat =~ s/\./\\./g;
    $mod = ($mod eq 'm') ? 'm' : 'y';

    lib::Debug->print($name, $pat);

    for (split /\n/, $body) {
	next unless s/^$pat\t+//;
	$descr = $_;
	last;
    }
    lib::Debug->print($name, $descr);

    $ACTIVE->new_group($name, $mod, $descr);

    lib::Debug->print($ACTIVE->group($name)->name);

    return 0;
}

sub rmgroup {
    my ($head, $body, $group) = @_;

    $ACTIVE->delete_group($group);
    print "Group $group is deleted.\n";

    return 0;
}

sub checkgroups {
    my ($head, $body, $param) = @_;

    return 0;
}

1;

# end
